#include <iostream>
#include "onStar.h"
#include "subject.h"
#include "vehicle.h"

using namespace std;

OnStar::OnStar(Vehicle &subject) : Observer{ &subject} {	
    _subject->subscribe(*this);
}

void OnStar::update() {
    // If this was real, we would update the database of onstar information on this specifc vehicle
    cout << endl;
    cout << "**ON STAR INFO UPDATE RECEIVED FROM VEHICLE**" << endl;

    // pull the properties of the vehicle
    cout << "Location of vehicle: : " << _subject->position() << endl;
    cout << "Current speed of vehicle : " << _subject->speed() << endl;	
    cout << "Doors are locked : " << std::boolalpha << _subject->locked() << endl;
    cout << "Lights are on : " << std::boolalpha << _subject->lightsOn() << endl;
    cout << "Engine Temperature : " << _subject->engineTemp() << endl;
    cout << "Windows are Open : " << std::boolalpha << _subject->windowsOpen() << endl;
    cout << "Vehicle VIN : " << _subject->VIN() << endl << endl;
}

// In the case of onstar, we would provide methods to 
//call into the subject and unlock the doors, turn off the lights etc etc
