#include "vehicle.h"
#include <string>
#include <iostream>
#include <math.h>

using namespace std;


// Initialize the vehicle object
// Economy specifies how much fuel is concumed for one unit of distance
Vehicle::Vehicle(double economy) : m_speed{0}, m_position{0.0f}, m_locked{false}, m_lights{false}, m_fuelLevel{1000},
    m_windows{false}, m_wipers{false}, m_engineTemp{20}, m_odometer{10000}, m_vin{1234567890}, m_isOn{false},
    m_systemTime{0}, m_economy{economy} {}


// Driving Methods (for test harness) in the actual application these would be set by the sensors in the vehicle
void Vehicle::turnOnCar() {
    m_isOn = true;
    m_engineTemp = 170;	
    notify();	
}

void Vehicle::driveDistance(int distance, int speed, bool atNight, bool inRain, bool windowsOpen) {
    m_isOn = true;
    m_engineTemp = 200;
    m_position += (double)distance;
    m_fuelLevel -= (distance * m_economy); // arbitrary constant
    m_odometer += abs(distance); // distance is a vector, odometers only go up, position can go up and down
    m_speed = speed;
    m_lights = atNight;
    m_wipers = inRain;
    m_windows = windowsOpen;
    notify();
}

void Vehicle::openTrunk() {
    // do nothing, real case, this would open the trunk
}

// Accessors and mutators
int Vehicle::speed() { return m_speed; }
double Vehicle::position() { return m_position; }
bool Vehicle::locked() { return m_locked; }
void Vehicle::lockedIs(bool locked) { m_locked = locked; }
bool Vehicle::lightsOn() { return m_lights; }
void Vehicle::lightsAre(bool on) { m_lights = on; }
bool Vehicle::windowsOpen() { return m_windows; }
void Vehicle::windowsAre(bool down) { m_windows = down; }
bool Vehicle::wipersOn() { return m_wipers; }
void Vehicle::wipersAre(bool on) { m_wipers = on; } 
int Vehicle::fuelLevel() { return m_fuelLevel; } 
int Vehicle::engineTemp() { return m_engineTemp; } 
long Vehicle::odometer() { return m_odometer; } 
long Vehicle::VIN() { return m_vin; } 
int Vehicle::systemTime() { return m_systemTime; }
